{$F+}

{*********************************************************}
{*                      TPKEY.PAS                        *}
{*                   DK   Inc.  1993                     *}
{*                 All rights reserved.                  *}
{*********************************************************}

Unit TpKey;
 { Handling keyboard input without BIOS }

Interface

Uses Dos;

Var
  Scan        : Byte;       { Last/current scan-code }
  Active      : Boolean;
  KbdFlags    : Byte absolute 0 : $417;
  KbdSwitch   : Byte absolute 0 : $418;
  OldInt9     : Pointer;
Const
  CallBIOS    : Boolean = True;

Function ReadScan : Byte;
{ Like a CRT.ReadKey, but check really any key; clears buffer }

Function WasKeyPressed : Boolean; { Like a CRT.KeyPressed, checks any key }

Function EmptyKeyBuffer : Boolean;

Procedure ClearBuffer;  { Clears keyboard buffer }

Procedure SetKbdFlags(Flags : Byte);

Implementation

Var
  ExitSave: Pointer;


Procedure NewInt9(var R : Registers); Interrupt;
Begin
  Active := True;
  Scan := Port[$60];
  if CallBios then Inline($9C/$3E/$FF/$1E/OldInt9) else asm
    mov al, 20h
    out 20h, al
  end;
  asm sti end;
End;

Procedure Exits;
Begin
  SetIntVec(9,OldInt9);
  Mem[Seg0040 : $1A] := Mem[Seg0040 : $1C];
  ExitProc := ExitSave;
End;

Function ReadScan : Byte;
Begin
  Active := False;
  Repeat Until Active;
  Mem[Seg0040 : $1A] := Mem[Seg0040 : $1C];
  ReadScan := Scan;
  Active := False;
End;

Function WasKeyPressed : Boolean;
Begin
  WasKeyPressed := Active;
End;

Procedure ClearBuffer;
Begin
  Mem[Seg0040 : $1A] := Mem[Seg0040 : $1C];
End;

Function EmptyKeyBuffer : Boolean;
Begin
  EmptyKeyBuffer := Mem[Seg0040 : $1A] = Mem[Seg0040 : $1C];
End;

Procedure SetKbdFlags(Flags : Byte);
Begin
  KbdFlags := Flags;
  asm
      push cx
      mov cl, 4
      shr flags, cl
      in  al, 64h
      mov cx, 2000
   @@0 : loop @@0
      mov al, 0edh
      out 64h, al
      mov cx, 2000
   @@1 : loop @@1
      mov al, flags
      out 64h, al
      pop cx
  end;
End;

Begin
  Active := False;
  ExitSave := ExitProc;
  ExitProc := @Exits;
  GetIntVec(9,OldInt9);
  SetIntVec(9,@NewInt9);
End.